<?php // PLUGIN_TITLE: Batch Annotate
$nozip = 1;
define('IN_CP', 1);
$root_path = (eregi("\/plugins\/", $PHP_SELF)) ? "./../../" : "./../";
define('ROOT_PATH', $root_path);
define('MEDIA_DIR', 'data/media');
define('MEDIA_PATH', ROOT_PATH.MEDIA_DIR);
require(ROOT_PATH.'admin/admin_global.php');
require(ROOT_PATH.'includes/annotate.php');

if ($action == "") {
  $action = "intro";
}

function init_convert_options() {
  global $config, $lang;

  $convert_options = array(
    "convert_error" => 0,
    "convert_tool" => $config['convert_tool'],
    "convert_path" => ereg_replace("\/$", "", $config['convert_tool_path'])
  );
  switch($config['convert_tool']) {
  case "im":
    $convert_options['convert_path'] = check_executable($convert_options['convert_path']);
    $convert_options['convert_path'] = preg_replace("/".check_executable("mogrify")."$/i", check_executable("convert"), $convert_options['convert_path']);
    if (!@is_executable($convert_options['convert_path'])) {
      $convert_options['convert_error'] = "<b class=\"marktext\">".$lang['im_error']."</b><br />\n".$lang['check_module_settings'];
    }
    break;
  case "gd":
    if (!extension_loaded("gd")) {
      $convert_options['convert_error'] = (defined("IN_CP")) ? "<b class=\"marktext\">".$lang['gd_error']."</b><br />\n".$lang['check_module_settings'] : 1;
    }
    break;
  case "netpbm":
    if (!@is_executable($convert_options['convert_path']."/".check_executable("pnmscale"))) {
      $convert_options['convert_error'] = (defined("IN_CP")) ? "<b class=\"marktext\">".$lang['netpbm_error']."</b><br />\n".$lang['check_module_settings'] : 1;
    }
    break;
  default:
    $convert_options['convert_error'] = (defined("IN_CP")) ? "<b class=\"marktext\">".$lang['no_convert_module']."</b><br />\n".$lang['check_module_settings'] : 1;
  }
  return $convert_options;
}

function next_step($batchstart, $batchsize, $cat_id, $autoredirect = 0) {
  global $site_sess;
  $page = $site_sess->url("batch_annotate.php?action=annotate&batchstart=".$batchstart."&batchsize=".$batchsize."&cat_id=".$cat_id."&autoredirect=".$autoredirect);
if ($autoredirect) {
?>
<script language="javascript">
myvar = "";
timeout = 15;
function dorefresh() {
  window.status="Redirecting"+myvar;
  myvar = myvar + " >";
  timerID = setTimeout("dorefresh();", 100);
  if (timeout > 0) {
    timeout -= 1;
  }
  else {
    clearTimeout(timerID);
    window.status="";
    window.location="<?php echo $page; ?>";
  }
}
dorefresh();
</script>
<?php
}
?>
<br />
<table border="0" cellspacing="0" cellpadding="1">
  <tr>
    <td class="tableseparator">
      <table width="100%" border="0" cellspacing="0" cellpadding="3">
        <tr>
          <td class="tablerow2" align="center">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="<?php echo $page; ?>"><b>Click here to continue</b></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<br />
<?php
}

show_admin_header();

if ($action == "intro") {

  $sql = "SELECT MIN(image_id) as min
          FROM ".IMAGES_TABLE;
  $row = $site_db->query_firstrow($sql);
  $min = (isset($row['min'])) ? $row['min'] : 0;

  show_form_header("batch_annotate.php", "annotate");
  show_table_header("Batch images annotation", 2);
  show_cat_select_row($lang['field_category'], "cat_id", 3);
  show_input_row("Number of images to do per cycle", "batchsize", 10);
  show_input_row("Image ID to start at", "batchstart", $min - 1);
  show_radio_row("Include automatic JavaScript redirect to next page", "autoredirect", 1);
  show_form_footer($lang['submit'], $lang['reset'], 2);
}

if ($action == "annotate") {

  if (isset($HTTP_GET_VARS['batchstart']) || isset($HTTP_POST_VARS['batchstart'])) {
    $batchstart = (isset($HTTP_GET_VARS['batchstart'])) ? intval($HTTP_GET_VARS['batchstart']) : intval($HTTP_POST_VARS['batchstart']);
  }
  else {
    $batchstart = 0;
  }

  if (isset($HTTP_GET_VARS['batchsize']) || isset($HTTP_POST_VARS['batchsize'])) {
    $batchsize = (isset($HTTP_GET_VARS['batchsize'])) ? intval($HTTP_GET_VARS['batchsize']) : intval($HTTP_POST_VARS['batchsize']);
    if (!$batchsize) {
      $batchsize = 25;
    }
  }
  else {
    $batchsize = 50;
  }

  if (isset($HTTP_GET_VARS['cat_id']) || isset($HTTP_POST_VARS['cat_id'])) {
    $cat_id = (isset($HTTP_GET_VARS['cat_id'])) ? intval($HTTP_GET_VARS['cat_id']) : intval($HTTP_POST_VARS['cat_id']);
  }
  else {
    $cat_id = 0;
  }

  if (isset($HTTP_GET_VARS['autoredirect']) || isset($HTTP_POST_VARS['autoredirect'])) {
    $autoredirect = (isset($HTTP_GET_VARS['autoredirect'])) ? intval($HTTP_GET_VARS['autoredirect']) : intval($HTTP_POST_VARS['autoredirect']);
  }
  else {
    $autoredirect = 0;
  }

  if ($cat_id != 0 && $cat_id != "") {
    $condition .= " AND i.cat_id = '$cat_id' AND i.cat_id = c.cat_id";
  }

  $sql = "SELECT MAX(image_id) as max
          FROM ".IMAGES_TABLE;
  $row = $site_db->query_firstrow($sql);
  $max = (isset($row['max'])) ? $row['max'] : 0;

  $batchend = $batchstart + $batchsize - 1;
  if ($batchend >= $max) {
    $batchend = $max;
  }

 if (!$cat_id) {
		echo "<b>No category selected, nothing to annotate...</b><p>";
		echo "<p><b>Finished!</b><p>\n";
	}
	else {
  echo "<b>Annotating between image ID ".$batchstart." and ".$batchend.":</b><p>";

  $sql = "SELECT * FROM ".IMAGES_TABLE." i, ".CATEGORIES_TABLE." c WHERE image_id BETWEEN $batchstart AND $batchend $condition";
  $result = $site_db->query($sql);
  while ($row = $site_db->fetch_array($result)) {
  $ann_src = MEDIA_PATH."/".$cat_id."/".$row['image_media_file'] ;
  if ($config['annotation_use'] && strtolower(get_file_extension($ann_src) == jpg)) {
  echo "Processing image <b>".$row['image_name']." </b>from category <b>".$row['cat_name']."</b>, image ID <b>".$row['image_id']."</b> >> ";
     $convert_options = init_convert_options();
          if (annotate_image($ann_src)) {
			echo " <b>OK</b><br />\n";
          } else { echo " <b>Skipped</b><br />\n"; }
  }
}
  if ($batchend < $max) {
    next_step($batchend + 1, $batchsize, $cat_id, $autoredirect);
  }
  else {
    echo "<p><b>Finished!</b><p>\n";
    show_text_link("Back", "batch_annotate.php");
  }
}
}
show_admin_footer();
?>